<?php
/*
Plugin Name: QuickShop
Plugin URI: http://www.zackdesign.biz/wp-plugins/34
Description: Quick and easy shopping cart with widget!
Author: Isaac Rowntree
Version: 1.2.2
Author URI: http://zackdesign.biz

	Copyright (c) 2005, 2006 Isaac Rowntree (http://zackdesign.biz)
	QuickShop is released under the GNU General Public
	License (GPL) http://www.gnu.org/licenses/gpl.txt

	This is a WordPress plugin (http://wordpress.org).

Changelog:

1.2.2

- Fixed changing product quantity on shopping cart widget
- Fixed Paypal form bug

1.2.1

- New TinyMCE Button

1.2

- Better Paypal integration. Now uses a new shopping cart widget instead!
- Quantity setting in sidebar widget
- Removal of extra Paypal tags to consolidate to just one tag.
- Added shipping by default

1.1

- Added product price
- Added tag for Paypal baskets

*/


session_start();

define('QUICKSHOP_URL_PATH', get_bloginfo('wpurl') . "/wp-content/plugins/quick-shop/");

if ($_POST['addcart'])
{
    if (!isset($_SESSION['cart']))
    {
        $_SESSION['cart'] = array();
    }
    $count = 1;
    foreach ($_SESSION['cart'] as $key => $item)
    {
        if ($item['name'] == $_POST['product'])
        {
            $count +=  $item['quantity'];
            $item['quantity']++;
            unset($_SESSION['cart'][$key]);
            array_push($_SESSION['cart'], $item);
        }
    }
    if ($count == 1)
    {
        $product = array('name' => $_POST['product'], 'price' => $_POST['price'], 'quantity' => $count, 'shipping' => $_POST['shipping'], 'shipping2' => $_POST['shipping2']);
        array_push($_SESSION['cart'], $product);
    }
    sort($_SESSION['cart']);
}
else if ($_POST['cquantity'])
{
    foreach ($_SESSION['cart'] as $key => $item)
    {
        if (($item['name'] == $_POST['product']) && $_POST['quantity'])
        {
            $item['quantity'] = $_POST['quantity'];
            unset($_SESSION['cart'][$key]);
            array_push($_SESSION['cart'], $item);
        }
        else if (($item['name'] == $_POST['product']) && !$_POST['quantity'])
            unset($_SESSION['cart'][$key]);
    }
    sort($_SESSION['cart']);
}
else if ($_POST['delcart'])
{
    foreach ($_SESSION['cart'] as $key => $item)
    {
        if ($item['name'] == $_POST['product'])
            unset($_SESSION['cart'][$key]);
    }
}


function widget_quickshop($args)
{

    extract($args);
    
    echo $before_widget;
    echo $before_title . 'Your Shopping Cart' . $after_title;
    
    echo '<div id="quickshopcart"><form method="post">';
    
    $count = 1;
    $total = 0;
    if ($_SESSION['cart'] && is_array($_SESSION['cart']))
    {
    foreach ($_SESSION['cart'] as $item)
    {
        echo "        
        <div id='quickshopitem' style='float: left; width: 60%;'>
        <form method=\"post\" style='display: inline'>
        <input type='hidden' name='product' value='".$item['name']."'>
        
        <input type='hidden' name='cquantity' value='1'><input type='text' name='quantity' value='".$item['quantity']."' size='1'></form>
        
        x ".$item['name']."</div>
        <div style='float: right; width: 10%;' id='quickshopremove'><form method=\"post\">
        <input type='hidden' name='product' value='".$item['name']."'>
        <input type='hidden' name='delcart' value='1'>
        <input type='image' src='".get_bloginfo('wpurl')."/wp-content/plugins/quick-shop/images/cart_remove.png' value='Remove' title='Remove'></form></div>
        <div style='float: right; width: 20%'><p>$".$item['price'] * $item['quantity']."</p></div>";
        $total += $item['price'] * $item['quantity'];
        $count += $item['quantity'];
    }
    }
    
    $count--;
    
    echo "
    
    <p style='font-weight: bold'>Total: $count item(s) in all worth $".$total."</p>";
    if ($count)
        echo "<p  style='font-weight: bold'><a href='/contact'>Proceed to Checkout <img src='".get_bloginfo('wpurl')."/wp-content/plugins/quick-shop/images/cart_go.png' title='Checkout' alt='Checkout'></a></p>";
    
    echo '</form></div>';
    
    echo $after_widget;

}

function widget_quickshoppaypal($args)
{

    extract($args);
    
    $email = get_bloginfo('admin_email');
    $paypal_currency = 'USD';
    
    echo $before_widget;
    echo $before_title . 'Your Shopping Cart' . $after_title;
    
    echo '<div id="quickshopcart">';
    
    $count = 1;
    $total_items = 0;
    $total = 0;
    $form = '';
    if ($_SESSION['cart'] && is_array($_SESSION['cart']))
    {
    foreach ($_SESSION['cart'] as $item)
    {
        echo "        
        <div id='quickshopitem' style='float: left; width: 60%;'>
        <form method=\"post\" style='display: inline'>
        <input type='hidden' name='product' value='".$item['name']."'>
        
        <input type='hidden' name='cquantity' value='1'><input type='text' name='quantity' value='".$item['quantity']."' size='1'></form>
        
        x ".$item['name']."</div>
        <div style='float: right; width: 10%;' id='quickshopremove'><form method=\"post\">
        <input type='hidden' name='product' value='".$item['name']."'>
        <input type='hidden' name='delcart' value='1'>
        <input type='image' src='".get_bloginfo('wpurl')."/wp-content/plugins/quick-shop/images/cart_remove.png' value='Remove' title='Remove'></form></div>
        <div style='float: right; width: 20%'><p>$".$item['price'] * $item['quantity']."</p></div>";
        
        $form .= "
            <input type=\"hidden\" name=\"item_name_$count\" value=\"".$item['name']."\">
            <input type=\"hidden\" name=\"amount_$count\" value='".$item['price']."'>
            <input type=\"hidden\" name=\"quantity_$count\" value=\"".$item['quantity']."\">
            <input type=\"hidden\" name=\"shipping_$count\" value=\"".$item['shipping']."\">
            <input type=\"hidden\" name=\"shipping2_$count\" value=\"".$item['shipping2']."\">
        ";
        
        $total += $item['price'] * $item['quantity'];
        $count++;
        $total_items +=  $item['quantity'];
    }
    }
    
    $count--;
    
    echo "<br />
    <form action=\"https://www.paypal.com/us/cgi-bin/webscr\" method=\"post\">$form
    <p style='font-weight: bold'>Total: $total_items item(s) in all worth $".$total."</p>";
    if ($count)
        echo '<input type="image" src="'.get_bloginfo('wpurl').'/wp-content/plugins/quick-shop/images/btn_xpressCheckout.gif" name="submit" alt="Make payments with PayPal - it\'s fast, free and secure!">';
    
    echo '
    <input type="hidden" name="business" value="'.$email.'">
    <input type="hidden" name="currency_code" value="'.$paypal_currency.'">
    <input type="hidden" name="cmd" value="_cart">
    <input type="hidden" name="upload" value="1">
    </form></div>';
    
    echo $after_widget;

}

function quickshop_widgets()
{

    register_sidebar_widget('QuickShop', 'widget_quickshop');
    
    register_sidebar_widget('QuickShop Paypal', 'widget_quickshoppaypal');

}

function quickshop_button_post($content)
{
    $forms = str_replace('[quickshop:',
    
    '<form method="post"  style="display:inline">
    <input type="submit" value="Add to Cart">
    <input type="hidden" name="product" value="',
    
    $content);
    
    $forms = str_replace(':price:',
    
    '"><input type="hidden" name="price" value="',
    
    $forms);
    
    $forms = str_replace(':shipping:',
    
    '"><input type="hidden" name="shipping" value="',
    
    $forms);
    
    $forms = str_replace(':shipping2:',
    
    '"><input type="hidden" name="shipping2" value="',
    
    $forms);
    
    $forms = str_replace(':end]',
    
    '"><input type="hidden" name="addcart" value="1"></form>',
    
    $forms);
    
    
    return $forms;
}

function quickshop_add2head() 
{
  $script = "<script type=\"text/JavaScript\" src=\"".QUICKSHOP_URL_PATH."fx.js\" language=\"javascript\"></script>\n";

  echo $script; 
}

add_action('plugins_loaded', 'quickshop_widgets');

//add_action('wp_head', 			'quickshop_add2head');

add_filter('the_content', 'quickshop_button_post');

//#################################################################
// TinyMCE Button Integration

// Load the Script for the Button
function insert_quickshop_script() {	
 
 	//TODO: Do with WP2.1 Script Loader
 	// Thanks for this idea to www.jovelstefan.de
 	
	echo "\n"."
	<script type='text/javascript'> 
		function quickshop_buttonscript()	{ 
		if(window.tinyMCE) {

			var template = new Array();
	
			template['file'] = '".QUICKSHOP_URL_PATH."quickshopbutton.php';
			
			template['width'] = 360;
			template['height'] = 210;
	
			args = {
				resizable : 'no',
				scrollbars : 'no',
				inline : 'yes'
			};
	
			tinyMCE.openWindow(template, args);
			return true;
		} 
	} 
	</script>"; 
	return;
}

function quickshop_addbuttons() {
 
	global $wp_db_version;

	// Don't bother doing this stuff if the current user lacks permissions
	if ( !current_user_can('edit_posts') && !current_user_can('edit_pages') ) return;
	 
	// Add only in Rich Editor mode
	if ( get_user_option('rich_editing') == 'true') {
	 
	// add the button for wp21 in a new way
		add_filter("mce_plugins", "quickshop_button_plugin", 5);
		add_filter('mce_buttons', 'quickshop_button', 5);
		add_action('tinymce_before_init','quickshop_button_script');
		}
}

// used to insert button in wordpress 2.1x editor
function quickshop_button($buttons) {

	array_push($buttons, "separator", "QuickShop");
	return $buttons;

}

// Tell TinyMCE that there is a plugin (wp2.1)
function quickshop_button_plugin($plugins) {    

	array_push($plugins, "-QuickShop");    
	return $plugins;
}

// Load the TinyMCE plugin : editor_plugin.js (wp2.1)
function quickshop_button_script() {	
 
 	$pluginURL =  QUICKSHOP_URL_PATH.'js/';
	echo 'tinyMCE.loadPlugin("QuickShop", "'.$pluginURL.'");' . "\n"; 
	return;
}

// init process for button control
add_action('init', 'quickshop_addbuttons');
add_action('edit_page_form', 'insert_quickshop_script');
add_action('edit_form_advanced', 'insert_quickshop_script');

//#################################################################


?>
